program QLSigMan;
{$X+}
{all other options as default}
uses App,stddlg,menus,objects,views,drivers,
     MsgBox,editors,memory,dialogs{,crt},strings;

const verstr= 'v1.3-19APR97';
{QLSigMan program
Copyright 1997 Gary Marsh - This program is Freeware, it can be freely copied
and distributed but the author retains all rights and copyright to it, meaning
no-one else can modify it without permission.
}



 {See about box}
{recent version progress:
16JAN97 Changes active sig file output slightly.  Added a confirmation box
        upon delete.
23JAN97 Fixed some potential bugs, finished testing.#
V1.2:
19FEB97 Extended character limit to 1200 chars from 900.  Changed MaxHeapSize
        to allow loading of larger files.  Improved error-checking.
V1.3:
19APR97 Doesn't add program info line, leaving just a blank line between
        quote and e-mail info.

written in Turbo Pascal 7.0 for DOS
}
const cmFileSetSigBase  =       200;  {menu commands}
      cmFileSetCurSig   =       201;
      cmFileSetEmInfo   =       202;
      cmFileViewLoc     =       220;
      cmSigsAdd         =       203;
      cmSigsDelete      =       204;
      cmSigsDisplay     =       205;
      cmChooseSig       =       206;
      cmHelpAbout       =       207;
      {AddSig Dialog}                  {dialog commands}
      cmAddSig          =       210;
      cmCancelSig       =       211;
      cmBack            =       212;
      cmForward         =       213;
      cmDelete          =       214;
      cmChoose          =       215;
      cmLast            =       216;
      {Misc.}
      cmFindSigAdd      =       244; {just for finding SigAddWindow}
      cmFindViewLocations  =    245; {ditto for ViewLocationsWin}
type Signat = PChar;
     PASignature = ^ASignature;
     ASignature = record
     SigData:PChar;
     Next, Previous:PASignature;
     end;
{     sigsfile = file of ASignature;}
     PSigAdd=^TSigAdd;
     TSigAdd = object(TDialog)
       constructor Init;
       procedure HandleEvent(var Event:TEvent); virtual;
       procedure AddASig;
       procedure BackSig;
       procedure ForwardSig;
       procedure DeleteSig;
       procedure ChooseSig;
     end;
     PViewLocations=^TViewLocations;
     TViewLocations = object(TDialog)
       constructor Init;
       procedure HandleEvent(var Event:TEvent); virtual;
     end;
     TSigDB = object(TApplication)
      ClipboardWindow:PEditWindow;
      SigAddWindow:PSigAdd;
      ViewLocationsWin:PViewLocations;
      constructor Init;
      procedure InitMenuBar; virtual;
      procedure HandleEvent(var Event:TEvent); virtual;
      procedure DoAbout;
      procedure SetSigBase;
      procedure SetCurSig;
      procedure SetEmInfo;
      procedure SigWindow;
      procedure OpenSigAdd;
      procedure OpenSigDisplay;
      procedure ChooseRandomSig;
      procedure ViewLoc;
     end;

var eminfo,sigscfg,active:text;
    CurrentSig,Previous,Root,mine,temp:PASignature;
    SigDB:TSigDB;
    SigsDBFile,SigsActiveFile,SigsEmInfoFile:FNameStr;
{    AddSigData:TSigBox;}
    membuf:^TMemodata;
    SigData:PMemo;
    CFGPresent:boolean;
    sigfile:text;{sigsfile;}
    {max sig length 900 chars, also in sig window init.
    In routs that read/write to files this limit is used incase null is
    missed/missing}
    ttemp:array[0..1200] of char;
    limit:integer;
type errarr = array[0..1] of LongInt;
     Perrarr = ^errarr;
var errArray:Perrarr;
    mess:array[0..110] of string;

procedure DisplayError(pars:PErrArr);
begin
  MessageBox(#3'Random Sig Generator'#13+#3'ERROR:%d'#13+#3'%s'
  ,pars, mfError or mfOKButton);
{  Dispose(ErrArray)}
end;

procedure GetError(Error:integer);
var loop:integer;

begin
  for loop:=1 to 110 do
    mess[loop]:='unknown, no message';
  mess[0]:='No error occurred';
  mess[2]:='File could not be found';
  mess[3]:='Path not be found';
  mess[4]:='Too many open files';
  mess[5]:='File access denied';


  mess[100]:='Disk read error';
  mess[101]:='Disk write error';
  mess[102]:='File not assigned';
  mess[103]:='File not open';
{  New(ErrArray);}
  ErrArray^[1]:=LongInt(@mess[Error]);
  ErrArray^[0]:=Error;
  DisplayError(ErrArray);
end;

procedure WriteCFG;
{writes 3 variables to the configuration file - overwrites old one}
begin
  rewrite(sigscfg);
  writeln(sigscfg,sigsDBFile);
  writeln(sigscfg,SigsActiveFile);
  writeln(sigscfg,SigsEmInfoFile);
  close(sigscfg);
end;

procedure writetosigsdb;
{writes the entire linked list to the sigsDB - this is done each
time a record is added.  It writes the PChar type by doing one char at a
time and stopping at the null char. }
{+++check if can be performed only on exit.}
var cnt,tmpio:integer;
    curchar:char;

begin
   rewrite(sigfile);
   mine:=root;
   while mine<>nil do
   begin
   cnt:=0;
      {$I-}
      repeat
        curchar:=mine^.sigdata[cnt];
        write(sigfile,curchar);
        inc(cnt);
        tmpio:=ioresult;
        if tmpio<>0 then GetError(tmpio);
      until (curchar=chr(0)) or (cnt>1200);{}
      {$I+}
      mine:=mine^.next;
   end;
    close(sigfile);
end;
procedure KillOldList;
{disposes of the linked list and strings contained in it}
begin
 mine:=root;
 while mine<>nil do
 begin
   previous:=mine;
  strdispose(mine^.sigdata);
  mine:=mine^.next;
  dispose(previous);
 end;
end;
procedure ReadFromSigsDB;
{reads from the SigsDB and generates a linked list from it.  PChar type is
built by reading a char at a time, the null char signalling the end of the
string}
var cnt,tmpio:integer;
    curchar:char;
begin
  limit:=0;
  {$I-}
  reset(sigfile);
  tmpio:=ioresult;
  {$I+}
  if tmpio=0 then
  begin {file exists}
   while eof(sigfile)=false do
   begin
     inc(limit);
     if root=nil then
     begin
       new(currentsig);
       cnt:=0;
       {$I-}
       repeat
        read(sigfile,curchar);
        tmpio:=ioresult;
        {  currentsig^.sigdata}ttemp[cnt]:=curchar;
        inc(cnt);
        if tmpio<>0 then GetError(tmpio);
       until (curchar=chr(0)) or (cnt>1200) or (tmpio<>0);
       {$I+}
       currentsig^.sigdata:=strnew(ttemp);
       root:=CurrentSig;
       currentsig^.previous:=nil;
       currentsig^.next:=nil
     end else
     begin
       previous:=CurrentSig;{}
       New(CurrentSig);
       cnt:=0;
       repeat
        read(sigfile,curchar);
        {  currentsig^.sigdata}ttemp[cnt]:=curchar;
        inc(cnt);
       until (curchar=chr(0)) or (cnt>1200);
       currentsig^.sigdata:=strnew(ttemp);
       Previous^.Next:=CurrentSig;
       CurrentSig^.Previous:=Previous;
       CurrentSig^.Next:=nil;
     end;

   end;
   close(sigfile);
  end{if file exists} else {display error} GetError(tmpio);
end;
procedure writetoactive;
{generates the actual sig - takes data from 3 sources, sigsDB, eminfo file
 and info about this program (optionally)}
var cnt,tmpio,eminfok,loop:integer;
    curchar,pch:char;
    trans:string[160];
    USDBF:array[0..80] of char;
begin
curchar:=' ';
assign(active,SigsActiveFile);
if sigseminfofile<>'' then assign(eminfo,SigsEmInfoFile);
rewrite(active);
if (currentSig^.sigdata[0]<>'-') then writeln(active,'-- '); {if no sig marker}
cnt:=0;                                                     {then make one}
{$I-}{turn off IO checking to enable error trapping}
      repeat
        pch:=curchar;
        curchar:=CurrentSig^.sigdata[cnt];
        if curchar<>chr(0) then write(active,curchar);
        inc(cnt);
        tmpio:=ioresult;
      if tmpio<>0 then GetError(tmpio);
      until (curchar=chr(0)) or (cnt>1200) or (tmpio<>0);{}

{$I+}{IO checking on again}
if tmpio=0 then {if no error occurred}
begin
if (pch<>chr(10)) and (pch<>chr(13)) then writeln(active); {if no return char put one in}
writeln(active);

{code to add info line if qlsigman.sdb is the sigsdbfile}
{  strpcopy(USDBF,SigsDBFile);
  for loop := 1 to Length(USDBF) do
  USDBF[loop] := UpCase(USDBF[loop]);
if (strpos(USDBF,'QLSIGMAN.SDB')<>nil) then
begin
  writeln(active,'<==The Quantum Leap quote was generated by QLSigMan, ftp QLSigMan.zip');
  writeln(active,'from the ql-archive - or see http://www.chasley.demon.co.uk/QLSigman/==>');
  writeln(active);
end;
}
{$I-}{IO checking off}
reset(eminfo);
eminfok:=ioresult;{was it successful? (does the file exist)}
{$I+}{IO checking on again}
if eminfok=0 then begin    {if file exists (no errors)}
while (eof(eminfo)=false) do
begin
readln(eminfo,trans);
writeln(active,trans);
end;
close(eminfo);
end {if eminfok}
else MessageBox(#3'Random Sig Generator'+#13+
  #3'Error opening e-mail info file -'+#13+#3+
  'No e-mail info added to the end.  Ziggy'
  ,nil,mfWarning or mfOKButton);

end;
close(active);
end;

{TSigAdd Methods}
{===============}

constructor TSigAdd.Init;
{generate the sigs window}
var r:Trect;

begin
  r.Assign(0,0,80,17);
  inherited Init(r,'Sig. Window');
  Options:=Options or ofCentered;
  HelpCtx:=$F000;
  r.Assign(1,2,79,13);
  SigData:=New(PMemo,Init(r,nil,nil,nil,1200));
  Insert(SigData);
  r.assign(1,14,12,16);
  Insert(New(PButton,Init(r,'~A~dd sig',cmAddSig,bfNormal)));
  r.assign(12,14,23,16);
  Insert(New(PButton,Init(r,'~C~ancel',cmCancelSig,bfDefault)));
  r.assign(23,14,34,16);
  Insert(New(PButton,Init(r,'~B~ack',cmBack,bfNormal)));
  r.assign(34,14,45,16);
  Insert(New(PButton,Init(r,'~F~orward',cmForward,bfNormal)));
  r.assign(45,14,56,16);
  Insert(New(PButton,Init(r,'~D~elete',cmDelete,bfNormal)));
    r.assign(56,14,67,16);
  Insert(New(PButton,Init(r,'C~h~oose',cmChoose,bfNormal)));
      r.assign(67,14,78,16);
  Insert(New(PButton,Init(r,'~L~ast',cmLast,bfNormal)));
  SelectNext(false);
end; {TSigAdd.Init}

procedure TSigAdd.AddASig;
{Add the sig to the linked list and then save the linked list to the file}
begin
  new(membuf);
  SigData^.GetData(membuf^);
   if root=nil then   {if no list yet}
   begin
     new(CurrentSig);
     CurrentSig^.SigData:=strnew(membuf^.buffer);
     root:=CurrentSig;
     CurrentSig^.Next:=nil;
     CurrentSig^.Previous:=nil;
   end else
   begin
     previous:=CurrentSig;
     New(CurrentSig);
     CurrentSig^.sigdata:=strnew(membuf^.buffer);
     CurrentSig^.Next:=previous^.Next;
     previous^.Next:=CurrentSig;
     CurrentSig^.Previous:=previous;
     CurrentSig^.Next^.Previous:=CurrentSig;
   end;
   Membuf^.length:=0;
   SigData^.SetData(membuf^);{clear after adding}
   dispose(membuf);
   writetosigsdb;
   inc(Limit);
end; {TSigAdd.AddASig}
procedure TSigAdd.BackSig;
{go to the previous record}
begin
CurrentSig:=CurrentSig^.Previous;
if CurrentSig^.Next<>nil then enableCommands([cmForward]);
 {root;} {//start at beginning}
if {curcount=0 } CurrentSig^.Previous=nil then disablecommands([cmBack]);
  new(membuf);
  membuf^.length:=strlen(CurrentSig^.sigdata);
  strcopy(membuf^.buffer,CurrentSig^.sigdata);
  SigData^.SetData(membuf^);
  dispose(membuf);
end;
procedure TSigAdd.ForwardSig;
{goto the next record}
begin
CurrentSig:=CurrentSig^.Next;
if CurrentSig^.Previous<>nil then enablecommands([cmBack]);
  new(membuf);
  membuf^.length:=strlen(CurrentSig^.sigdata);
  strcopy(membuf^.buffer,CurrentSig^.sigdata);
  SigData^.SetData(membuf^);
  dispose(membuf);
if CurrentSig^.Next=nil then disableCommands([cmForward]);
end;
procedure TSigAdd.DeleteSig; {Contradicition in terms! :) }
{delete the currently selected sig.  Simply removes the pointers to it and
rejoins the linked list}
var conf:word;
begin
conf:=MessageBox(#3'Delete this sig'+#13+#3+
'Are you sure?',nil,mfConfirmation
  or mfYesButton or mfNoButton);
if (conf=cmYes) then begin
{}
if (CurrentSig^.Previous=nil) and (CurrentSig^.Next<>nil) then
  begin
    root:=CurrentSig^.Next;
    CurrentSig:=root;
    strDispose(CurrentSig^.Previous^.sigdata);
    Dispose(CurrentSig^.Previous);
    CurrentSig^.Previous:=nil;
    new(membuf);
    membuf^.length:=strlen(CurrentSig^.sigdata);
    strcopy(membuf^.buffer,CurrentSig^.sigdata);
    SigData^.SetData(membuf^);
    dispose(membuf);
    WriteToSigsDB;
    if CurrentSig^.Next=nil then Disablecommands([cmForward]);
  end else
if (CurrentSig^.Previous<>nil) and (CurrentSig^.Next=nil) then
  begin
    CurrentSig:=CurrentSig^.Previous;
    strdispose(CurrentSig^.Next^.sigdata);
    Dispose(CurrentSig^.Next);
    CurrentSig^.Next:=nil;
    new(membuf);
    membuf^.length:=strlen(CurrentSig^.sigdata);
    strcopy(membuf^.buffer,CurrentSig^.sigdata);
    SigData^.SetData(membuf^);
    dispose(membuf);
    WriteToSigsDB;
    if CurrentSig^.Previous=nil then Disablecommands([cmBack]);
  end else
if (CurrentSig^.Previous<>nil) and (CurrentSig^.Next<>nil) then
begin
  CurrentSig^.Previous^.Next:=CurrentSig^.Next;
  CurrentSig^.Next^.Previous:=CurrentSig^.Previous;
  temp:=currentsig;
  CurrentSig:=CurrentSig^.Previous;
  strdispose(temp^.sigdata);
  dispose(temp);
  new(membuf);
  membuf^.length:=strlen(CurrentSig^.sigdata);
  strcopy(membuf^.buffer,CurrentSig^.sigdata);
  SigData^.SetData(membuf^);
  dispose(membuf);
  WriteToSigsDB;
  if CurrentSig^.Previous=nil then Disablecommands([cmBack]);
  if CurrentSig^.Next=nil then Disablecommands([cmForward]);
end else
if (CurrentSig^.Previous=nil) and (CurrentSig^.Next=nil) then
begin
root:=nil;
disablecommands([cmDelete,cmChoose,cmLast]);
new(membuf);
   Membuf^.length:=0;
   SigData^.SetData(membuf^);{clear after adding}
   dispose(membuf);
   WriteToSigsDB;
end;
dec(limit);
end; {if confirmed to delete}
end;

procedure TSigAdd.ChooseSig;
{this proc (writetoactive) is necessary because with objects close is taken
as to close the object and produces a compile time error}
begin
  writetoactive;
end;

procedure TSigAdd.HandleEvent(var Event:TEvent);
begin
  inherited HandleEvent(Event);
  if (Event.What = evBroadcast) and (Event.Command = cmFindSigAdd)
    then ClearEvent(Event) else
  if Event.What = evCommand then
    case Event.Command of
      cmAddSig:begin
                    AddaSig;
                    ClearEvent(Event);
      end;
      cmBack:begin

                    BackSig;
                    ClearEvent(Event);
      end;
      cmForward:begin
                    ForwardSig;
                    ClearEvent(Event);
      end;
      cmDelete:begin
                       DeleteSig;
                       ClearEvent(Event);
      end;
      cmChoose:begin
                        ChooseSig;
                        ClearEvent(Event);
      end;
      cmCancelSig:begin
                       Close;
                       ClearEvent(Event);
      end;
      cmLast:begin
                        {select last record}
                        while (CurrentSig^.Next<>nil) do
                        begin
                          CurrentSig:=CurrentSig^.Next;
                        end; {now last record is current}
                        {disable back command if adding}
                        if (CurrentSig^.Previous<>nil) and (CommandEnabled(cmAddSig)=false) then enablecommands([cmBack]);
                        if (CommandEnabled(cmAddSig)=false) then
                        {if addsig version then don't display last sig}
                        begin
                        new(membuf);
                        membuf^.length:=strlen(CurrentSig^.sigdata);
                        strcopy(membuf^.buffer,CurrentSig^.sigdata);
                        SigData^.SetData(membuf^);
                        dispose(membuf);
                        end;
                        disableCommands([cmForward]);
                        ClearEvent(Event);

      end;
    end;
end;

{TViewLocations Methods}
{======================}
constructor TViewLocations.Init;
{Initialise the dialog that will show locations of the 3 main files}
var r:TRect;
    Myfield,emfield,acfield:PInputLine;
begin
  R.Assign(0,0,70,7);
  inherited Init(R,'View Locations');
  Options:=Options or ofCentered;
    R.Assign(19,2,69,3);{boundaries for input field}
  myfield:=new(PInputLine, Init(r,150)); {construct}
  insert(myfield);                     {insert}
  r.assign(1,2,18,3);
  insert(new(PLabel,Init(r,'SigBase file:',myfield)));
  R.Assign(19,3,69,4);{boundaries for input field}
  acfield:=new(PInputLine, Init(r,150)); {construct}
  insert(acfield);                     {insert}
  r.assign(1,3,18,4);
  insert(new(PLabel,Init(r,'Active sig file:',acfield)));
  R.Assign(19,4,69,5);{boundaries for input field}
  emfield:=new(PInputLine, Init(r,150)); {construct}
  insert(emfield);                     {insert}
  r.assign(1,4,18,5);
  insert(new(PLabel,Init(r,'E-mail inf file:',emfield)));

  if SigsActiveFile<>'' then acfield^.data^:=SigsActiveFile
    else acfield^.data^:='WARNING! NOT DEFINED - An active sig file must be selected';
  if SigsEmInfoFile<>'' then emfield^.data^:=SigsEmInfoFile
    else emfield^.data^:='WARNING! NOT DEFINED - Sig will have no e-mail/other info added';
  if SigsDBFile<>'' then myfield^.data^:=SigsDBFile
    else myfield^.data^:='WARNING! NOT DEFINED - A Sigs DB must be used to get the quotes from';
end;
procedure TViewLocations.HandleEvent(var Event:TEvent);
begin
  inherited HandleEvent(Event);
  if (Event.What = evBroadcast) and (Event.Command = cmFindViewLocations)
  then ClearEvent(Event);
end;
{end of TViewLocations methods}

{TSigDB Methods}
{==============}

constructor TSigDB.Init;
var r:TRect;
begin
  {initialse vars}
  MaxHeapSize:=8197+16384; {setup file edit buffer above heap}{was 8197}
  EditorDialog:=StdEditorDialog; {use standard editor dialogs}
  SigsDBFile:='';    {set values to '' just incase :) }
  SigsActiveFile:='';
  SigsEmInfoFile:='';
  root:=nil; {root is the first record in the linked list}
  previous:=nil;
  CurrentSig:=nil;
{  CurrentSig:=root;     }
 { next:=root;}
  {$I-} {turn off IO checking}
  reset(sigscfg);{Open to read file locations from CFG file}
  CFGPresent:=(IOResult=0); {if 0 then no error}
  {$I+} {turn on IO checking}
  if CFGPresent then begin
  while not eof(sigscfg) do
  begin
  readln(sigscfg,SigsDBFile);
  readln(sigscfg,SigsActiveFile);
  readln(sigscfg,SigsEmInfoFile);
 end;
  close(Sigscfg);
  end;
  inherited init;
  Desktop^.GetExtent(r);
  ClipboardWindow:=New(PEditWindow,Init(R,'',wnNoNumber));
  {make a clipboard window to enable cut and paste of sigs}
  If ValidView(ClipboardWindow) <> nil then {make sure it worked}
    begin
     ClipboardWindow^.Hide;
     InsertWindow(ClipboardWindow); {insert clipboard}
     Clipboard:=ClipboardWindow^.Editor;
     Clipboard^.CanUndo:=false; {no undo for clipboard}
    end;
  if CFGPresent=false then MessageBox(#3'Random Sig Generator'+#13+
  #3'Error opening config file - the'+#13+#3+
  'file locations must be entered.  Ziggy'
  ,nil,mfWarning or mfOKButton);{ else
  begin                          }
  if  SigsDBFile='' then
  begin
  MessageBox(#3'Random Sig Generator'+#13+
  #3'Sigs DB file not found, please'+#13+#3+
  'enter location (option in'+#13+#3+'the file menu).  Ziggy',nil,mfWarning or mfOKButton);
  disablecommands([cmSigsAdd,cmSigsDelete,cmSigsDisplay,cmChooseSig]);
  end else
  begin
  assign(sigfile,SigsDBFile);
  ReadFromSigsDB;
  end;
  if SigsActiveFile='' then
  begin
   MessageBox(#3'Random Sig Generator'+#13+#3'Active sig file not found, please'+#13+#3+
   'enter location (option in'+#13+#3+'the file menu).  Ziggy',nil,mfWarning or mfOKButton);
   disablecommands([cmChooseSig,cmChoose]);
  end;
   if SigsEmInfoFile='' then
   begin
   MessageBox(#3'Random Sig Generator'+#13+#3'e-mail info file not found, please'+#13+#3+
   'enter location (option in'+#13+#3+'the file menu).  Ziggy',nil,mfWarning or mfOKButton);
{   disablecommands([cmChooseSig,cmChoose]);}
   end;
{  end;}
end;
procedure TSigDB.SetSigBase;
var filedialog:pfiledialog;
    TheFile:FNameStr;
    any:text;
    IsItEmpty:boolean;
const
     FDOptions:word = fdOKButton or fdOpenButton;
begin
  TheFile:='*.*';
  New(FileDialog,Init(TheFile,'Select SigsBase File','~F~ile name',
  FDOptions,1));
  if ExecuteDialog(FileDialog,@TheFile)<>cmCancel then
  begin
{    MessageBox(#3'Load that file',nil,mfInformation or mfOKButton);}
    SigsDBFile:=TheFile;
    root:=nil;
    WriteCFG;
    assign(sigfile,SigsDBFile);
    IsItEmpty:=true;
    assign(any,SigsDBFile);
    {$I-} {turn off IO checking}
    reset(any);
    IsItEmpty:=(IOResult<>0) or (eof(any));
    {$I+} {back on again}
    if IsItEmpty=false then
    begin
    close(any);
    KillOldList;
    ReaDFromSigsDB;
    end else
    begin
    rewrite(any);
    close(any);
    KillOldList;
    ReadFromSigsDB;
    end;
    enablecommands([cmSigsAdd,cmSigsDelete,cmSigsDisplay]);
    if (SigsActiveFile<>''){and(emInfoFile<>'') }then enablecommands([cmChooseSig,cmChoose]);
  end;
end;
procedure TSigDB.SetCurSig;
var filedialog:pfiledialog;
    TheFile:FNameStr;
const
     FDOptions:word = fdOKButton or fdOpenButton;
begin
  TheFile:='*.*';
  New(FileDialog,Init(TheFile,'Select Active Sig File','~F~ile name',
  FDOptions,1));
  if ExecuteDialog(FileDialog,@TheFile)<>cmCancel then
  begin
{    MessageBox(#3'Load that file',nil,mfInformation or mfOKButton);}
    SigsActiveFile:=TheFile;
    WriteCFG;
    if (SigsDBFile<>''){and(SigsEmInfoFile<>'')} then enablecommands([cmChooseSig,cmChoose]);

  end;
end;
procedure TSigDB.SetEmInfo;
var filedialog:pfiledialog;
    TheFile:FNameStr;
const
     FDOptions:word = fdOKButton or fdOpenButton;
begin
  TheFile:='*.*';
  New(FileDialog,Init(TheFile,'Select E-mail Info File','~F~ile name',
  FDOptions,1));
  if ExecuteDialog(FileDialog,@TheFile)<>cmCancel then
  begin
    SigsEmInfoFile:=TheFile;
    WriteCFG;
    if (SigsActiveFile<>'')and(SigsDBFile<>'') then enablecommands([cmChooseSig,cmChoose]);

  end;
end;
procedure TSigDB.ViewLoc;
begin
if Message(Desktop,evBroadCast,cmFindViewLocations,nil)=nil then
{if window not open..}
begin
ViewLocationsWin:=New(PViewLocations,Init);{...then open...}
Application^.InsertWindow(ViewLocationsWin);
end else if PView(ViewLocationsWin)<> Desktop^.TopView
    then ViewLocationsWin^.Select; {..else bring it into view}
end;

procedure TSigDB.SigWindow;
var
  r:TRect;
  TheWindow:PEditWindow;
begin
  r.Assign(0,0,60,20);
  New(TheWindow,Init(r,'',wnNoNumber));
  InsertWindow(TheWindow);
end; {TSigDB.SigWindow}

procedure TSigDB.OpenSigAdd;
begin
  if Message(Desktop,evBroadcast,cmFindSigAdd,nil)=nil then
  begin
    SigAddWindow:=New(PSigAdd,Init);
    Application^.InsertWindow(SigAddWindow);
  end
  else
    If PView(SigAddWindow)<>Desktop^.TopView
      then SigAddWindow^.Select; {selects the SigAddWindow if not already}
  EnableCommands([cmAddSig,cmCancel]);
  DisableCommands([cmBack,cmForward,cmDelete,cmChoose,cmLast]);
  if currentsig<>nil then enablecommands([cmLast]);

end; {TSigDB.OpenSigAdd}

procedure TSigDB.OpenSigDisplay;
begin
  if Message(Desktop,evBroadcast,cmFindSigAdd,nil)=nil then
  begin
    SigAddWindow:=New(PSigAdd,Init);
    Application^.InsertWindow(SigAddWindow);
  end
  else
    If PView(SigAddWindow)<>Desktop^.TopView
      then SigAddWindow^.Select; {selects the SigAddWindow if not already}
      EnableCommands([cmCancel,cmForward,cmDelete]);
  DisableCommands([cmAddSig,cmBack,cmChoose]);
  if (SigsActiveFile<>''){and(SigsEmInfoFile<>'')}and (root<>nil) then enablecommands([cmChoose]);


  {display firstsig}
  currentsig:=root;
  previous:=nil;
  if CurrentSig<>nil then
  begin
  new(membuf);
  membuf^.length:=strlen(CurrentSig^.sigdata);
  strcopy(membuf^.buffer,CurrentSig^.sigdata);
  SigData^.SetData(membuf^);
  dispose(membuf);
  if CurrentSig^.next=nil then DisableCommands([cmForward]);
  end else DisableCommands([cmForward,cmBack,cmDelete]);
end; {TSigDB.OpenSigDisplay}

procedure TSigDB.ChooseRandomSig;
var cursig,reqsig:integer;
begin
randomize;
reqsig:=random(limit)+1; {choose a number within the boundaries of the file}
currentSig:=root;
cursig:=1;
while cursig<>reqsig do
begin
CurrentSig:=CurrentSig^.Next;
inc(cursig);
end;
writetoactive; {generate the sig file}
end;

procedure TSigDB.DoAbout;
begin                    {#3=centre, #13=line-break}
  MessageBox(#3'Random Sig Generator'#13+#3+verstr+{'v1.3-12APR97}', (C)1997 Gary J Marsh'#13+
  #3'This program is Freeware, see docs for info',nil,mfInformation
  or mfOKButton); {Title & OK Button}
end; {TSigDB.DoAbout}
procedure TSigDB.InitMenuBar;
var r:TRect;
begin
  GetExtent(r);
  r.b.y:=1;
  MenuBar:=New(PMenuBar,Init(r,NewMenu(NewSubMenu('~F~ile',hcNoContext,
      NewMenu(NewItem('~S~et Sigbase','F3',kbF3,cmFileSetSigBase,hcNoContext,
      NewItem('~A~ctive Sig','F4',kbF4,cmFileSetCurSig,hcNoContext,
      NewItem('~E~-mail info file','F5',kbF5,cmFileSetEmInfo,hcNoContext,
      NewItem('~V~iew file locations','Alt+V',kbAltV,cmFileViewLoc,hcNoContext,
      NewLine(NewItem('E~x~it','Alt+X',kbAltX,cmQuit,hcNoContext,
      nil))))))),NewSubMenu('~E~dit', hcNoContext, NewMenu(
      StdEditMenuItems(nil)),NewSubMenu('~S~igs',hcNoContext,NewMenu(NewItem('~A~dd Sig',
      'F6',kbF6,cmSigsAdd,hcNoContext,NewItem('~D~elete Sig','F7',kbF7,
      cmSigsDelete,hcNoContext,NewItem('D~i~splay Sigs','F8',kbF8,
      cmSigsDisplay,hcNoContext,nil)))),NewItem('~C~hoose Sig','F9',kbF9,
      cmChooseSig,hcNoContext,NewSubMenu('~H~elp',hcNoContext,
      NewMenu(NewItem('~A~bout','Alt+A',kbAltA,cmHelpAbout,hcNoContext,{}nil{})),nil))))))));
end; {TSigDB.InitMenuBar}
procedure TSigDB.HandleEvent(var Event:TEvent);
begin
  inherited HandleEvent(Event);
  if Event.What = evCommand then
  case Event.Command of
    cmFileSetSigBase:
      begin
        SetSigBase;
        ClearEvent(Event);
      end;
    cmFileSetCurSig:
      begin
        SetCurSig;
        ClearEvent(Event);
      end;
    cmFileSetEmInfo:
      begin
        SetEmInfo;
        ClearEvent(Event);
      end;
    cmFileViewLoc:
      begin
        ViewLoc;
        ClearEvent(Event);
      end;
    cmSigsAdd:begin
                   OpenSigAdd;
                   ClearEvent(Event);
    end;
    cmSigsDisplay,cmSigsDelete:begin
                                    OpenSigDisplay;
                                    ClearEvent(Event);
    end;
    cmChooseSig:begin
                     ChooseRandomSig;
                     ClearEvent(Event);
    end;
    cmHelpAbout:
      begin
        DoAbout;
        ClearEvent(Event);
      end;
  end;
end; {TSigDB.HandleEvent}

begin
  Assign(Sigscfg,{'C:\GARYS\}'SIGSDB.CFG');
{  assign(sigfile,'c:\garys\sig.dat');}
  {rewrite(sigscfg);}
  SigDB.Init;
  SigDB.Run;
  SigDB.Done;
  {===Dispose of linked list strings and records===}
  KillOldList;
end.